# Device overview

A typical calibration pipeline will contain the following device roles:

- One [manager](middlelayer.md#calibration-manager) responsible for instantiating and configuring the pipeline
    - Exception: some single-module detectors (some JUNGFRAU, GOTTHARD-II)
- One [correction device](correction-devices.md) per detector module, processing the detector data
    - Arranged in groups
    - AGIPD1M@SPB, AGIPD1M@MID, LPD1M@FXE, DSSC1M@1MSQS/SCS: 4 groups of 4 correction devices
    - JF4M@SPB (in GPU mode): 1 group with all 8 correction devices
- Optionally one [group matcher](matchers.md#group-matcher) per group responsible for sending data out from the processing node
    - Can send to online analysis via Karabo bridge
    - Can send to full matcher via regular Karabo channel
- Optionally one [full matcher](matchers.md#full-matcher) - same as group matcher, but for full detector
- One preview assembler per preview layer (at least raw and corrected)
- One geometry device


The following diagram illustrates the data flow between devices.
For readability, the diagram only includes one module in one group, only shows one preview layer, and omits manager and geometry devices (these don't use fast data channels).

![](../static/pipeline-overview-simplified.svg "Simplified data flow overview")
