# Agipd1MGeometry
Base classes: ManualQuadrantsGeometryBase
## <a name='availableScenes'></a>Available scenes (`availableScenes`)
Type
: VECTOR_STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``['overview']``

## Geometry preview (`geometryPreview`)
ImageData
## Geometry file (`geometryFile`)
Allows loading geometry from CrystFEL geometry file
### <a name='geometryFile.filePath'></a>File path (`geometryFile.filePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Full path (including filename and suffix) to the desired geometry file. Keep in mind that the default directory is $KARABO/var/data on device server node, so it's probably wise to give absolute path.

Default value
: empty string

### <a name='geometryFile.fileType'></a>File type (`geometryFile.fileType`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: What kind of file will be loaded. Corresponds to options within EXtra-geom. Note that the options listed here may not all apply to all geometries. I think 'crystfel' (uses extra_geom.[geometry type].from_crystfel_geom is the most 'universal', so I left that as default.

Options:
: ``crystfel``, ``h5``, ``h5+quadrants``

Default value
: ``crystfel``

### Offset (`geometryFile.offset`)
See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.
#### <a name='geometryFile.offset.x'></a>`geometryFile.offset.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

#### <a name='geometryFile.offset.y'></a>`geometryFile.offset.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

### <a name='geometryFile.offset'></a>Offset (`geometryFile.offset`)
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.

### <a name='geometryFile.updateManualOnLoad'></a>Update manual settings (`geometryFile.updateManualOnLoad`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this flag is on, the manual settings on this device will be updated according to the loaded geometry file. This is useful when you want to load a file and then tweak the geometry a bit. This will zero current offset.

Default value
: ``True``

### <a name='geometryFile.updateMotorReferenceOnLoad'></a>Update motor reference (`geometryFile.updateMotorReferenceOnLoad`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this flag is on, the motor reference positions in the motor tracking node will be updated according to the motor positions stored in geometry file.

Default value
: ``True``

### <a name='geometryFile.loadFromFile'></a>Load from file (`geometryFile.loadFromFile`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## <a name='geometryFile'></a>Geometry file (`geometryFile`)
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Allows loading geometry from CrystFEL geometry file

## Tweak geometry (`tweakGeometry`)
### <a name='tweakGeometry.undo'></a>Undo (`tweakGeometry.undo`)
Type
: Slot

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='tweakGeometry.redo'></a>Redo (`tweakGeometry.redo`)
Type
: Slot

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### Offset (`tweakGeometry.offset`)
See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.
#### <a name='tweakGeometry.offset.x'></a>`tweakGeometry.offset.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

#### <a name='tweakGeometry.offset.y'></a>`tweakGeometry.offset.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

### <a name='tweakGeometry.offset'></a>Offset (`tweakGeometry.offset`)
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.

### <a name='tweakGeometry.add'></a>Add offset (`tweakGeometry.add`)
Type
: Slot

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='tweakGeometry.undoLength'></a>Undo length (`tweakGeometry.undoLength`)
Type
: INT32

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0``

### <a name='tweakGeometry.redoLength'></a>Redo length (`tweakGeometry.redoLength`)
Type
: INT32

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0``

## <a name='tweakGeometry'></a>Tweak geometry (`tweakGeometry`)
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## <a name='sendGeometry'></a>Send geometry (`sendGeometry`)
Type
: Slot

Allowed in states
: ACTIVE, MONITORING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Will send 'signalNewGeometry' to connected slots. These will for example be DetectorAssembler. Note that signal is sent automatically when new geometry is set - this slot is mostly to be called by manager after (re)starting assemblers while geometry device is still up.

## <a name='updatePreview'></a>Update preview (`updatePreview`)
Type
: Slot

Allowed in states
: ACTIVE, MONITORING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## `quadrantCorners`
### Offset (`quadrantCorners.offset`)
See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.
#### <a name='quadrantCorners.offset.x'></a>`quadrantCorners.offset.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

#### <a name='quadrantCorners.offset.y'></a>`quadrantCorners.offset.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

### <a name='quadrantCorners.offset'></a>Offset (`quadrantCorners.offset`)
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: See EXtra-geom documentation for details. This offset is applied to entire detector after initial geometry is created from manual parameters. Example: To move entire geometry up by 2 mm relative to beam, set offset.y to 2e-3.

### <a name='quadrantCorners.setManual'></a>Set manual geometry (`quadrantCorners.setManual`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### `quadrantCorners.Q1`
#### <a name='quadrantCorners.Q1.x'></a>`quadrantCorners.Q1.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``-525.0``

#### <a name='quadrantCorners.Q1.y'></a>`quadrantCorners.Q1.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``625.0``

### <a name='quadrantCorners.Q1'></a>`quadrantCorners.Q1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### `quadrantCorners.Q2`
#### <a name='quadrantCorners.Q2.x'></a>`quadrantCorners.Q2.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``-550.0``

#### <a name='quadrantCorners.Q2.y'></a>`quadrantCorners.Q2.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``-10.0``

### <a name='quadrantCorners.Q2'></a>`quadrantCorners.Q2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### `quadrantCorners.Q3`
#### <a name='quadrantCorners.Q3.x'></a>`quadrantCorners.Q3.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``520.0``

#### <a name='quadrantCorners.Q3.y'></a>`quadrantCorners.Q3.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``-160.0``

### <a name='quadrantCorners.Q3'></a>`quadrantCorners.Q3`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### `quadrantCorners.Q4`
#### <a name='quadrantCorners.Q4.x'></a>`quadrantCorners.Q4.x`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``542.5``

#### <a name='quadrantCorners.Q4.y'></a>`quadrantCorners.Q4.y`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``475.0``

### <a name='quadrantCorners.Q4'></a>`quadrantCorners.Q4`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## <a name='quadrantCorners'></a>`quadrantCorners`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## `motorTracking`
### <a name='motorTracking.state'></a>`motorTracking.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Options:
: ``UNKNOWN``, ``KNOWN``, ``INIT``, ``ERROR``, ``INTERLOCKED``, ``NORMAL``, ``STATIC``, ``INTERLOCK_OK``, ``CHANGING``, ``DECREASING``, ``COOLING``, ``MOVING_LEFT``, ``MOVING_DOWN``, ``MOVING_BACK``, ``ROTATING_CNTCLK``, ``RAMPING_DOWN``, ``EXTRACTING``, ``STOPPING``, ``EMPTYING``, ``DISENGAGING``, ``SWITCHING_OFF``, ``HOMING``, ``ROTATING``, ``MOVING``, ``SWITCHING``, ``OPENING``, ``CLOSING``, ``SEARCHING``, ``INCREASING``, ``HEATING``, ``MOVING_RIGHT``, ``MOVING_UP``, ``MOVING_FORWARD``, ``ROTATING_CLK``, ``RAMPING_UP``, ``INSERTING``, ``STARTING``, ``FILLING``, ``ENGAGING``, ``SWITCHING_ON``, ``PAUSED``, ``RUNNING``, ``ACQUIRING``, ``PROCESSING``, ``PASSIVE``, ``WARM``, ``COLD``, ``PRESSURIZED``, ``CLOSED``, ``OFF``, ``INSERTED``, ``STOPPED``, ``UNLOCKED``, ``DISENGAGED``, ``IGNORING``, ``ACTIVE``, ``COOLED``, ``HEATED``, ``EVACUATED``, ``OPENED``, ``ON``, ``EXTRACTED``, ``STARTED``, ``LOCKED``, ``ENGAGED``, ``MONITORING``, ``DISABLED``, ``INTERLOCK_BROKEN``

Default value
: ``OFF``

### <a name='motorTracking.runOnStartup'></a>`motorTracking.runOnStartup`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

### <a name='motorTracking.motorPattern'></a>`motorTracking.motorPattern`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

### `motorTracking.motorsConfig`
#### `motorTracking.motorsConfig.Q1`
##### `motorTracking.motorsConfig.Q1.M1`
###### <a name='motorTracking.motorsConfig.Q1.M1.axisVector'></a>`motorTracking.motorsConfig.Q1.M1.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[0.0, -1.0]``

###### <a name='motorTracking.motorsConfig.Q1.M1.deviceId'></a>`motorTracking.motorsConfig.Q1.M1.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q1.M1.referencePos'></a>`motorTracking.motorsConfig.Q1.M1.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q1.M1.currentPos'></a>`motorTracking.motorsConfig.Q1.M1.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q1.M1'></a>`motorTracking.motorsConfig.Q1.M1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

##### `motorTracking.motorsConfig.Q1.M2`
###### <a name='motorTracking.motorsConfig.Q1.M2.axisVector'></a>`motorTracking.motorsConfig.Q1.M2.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[-1.0, 0.0]``

###### <a name='motorTracking.motorsConfig.Q1.M2.deviceId'></a>`motorTracking.motorsConfig.Q1.M2.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q1.M2.referencePos'></a>`motorTracking.motorsConfig.Q1.M2.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q1.M2.currentPos'></a>`motorTracking.motorsConfig.Q1.M2.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q1.M2'></a>`motorTracking.motorsConfig.Q1.M2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.motorsConfig.Q1'></a>`motorTracking.motorsConfig.Q1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### `motorTracking.motorsConfig.Q2`
##### `motorTracking.motorsConfig.Q2.M1`
###### <a name='motorTracking.motorsConfig.Q2.M1.axisVector'></a>`motorTracking.motorsConfig.Q2.M1.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[0.0, -1.0]``

###### <a name='motorTracking.motorsConfig.Q2.M1.deviceId'></a>`motorTracking.motorsConfig.Q2.M1.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q2.M1.referencePos'></a>`motorTracking.motorsConfig.Q2.M1.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q2.M1.currentPos'></a>`motorTracking.motorsConfig.Q2.M1.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q2.M1'></a>`motorTracking.motorsConfig.Q2.M1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

##### `motorTracking.motorsConfig.Q2.M2`
###### <a name='motorTracking.motorsConfig.Q2.M2.axisVector'></a>`motorTracking.motorsConfig.Q2.M2.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[1.0, 0.0]``

###### <a name='motorTracking.motorsConfig.Q2.M2.deviceId'></a>`motorTracking.motorsConfig.Q2.M2.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q2.M2.referencePos'></a>`motorTracking.motorsConfig.Q2.M2.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q2.M2.currentPos'></a>`motorTracking.motorsConfig.Q2.M2.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q2.M2'></a>`motorTracking.motorsConfig.Q2.M2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.motorsConfig.Q2'></a>`motorTracking.motorsConfig.Q2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### `motorTracking.motorsConfig.Q3`
##### `motorTracking.motorsConfig.Q3.M1`
###### <a name='motorTracking.motorsConfig.Q3.M1.axisVector'></a>`motorTracking.motorsConfig.Q3.M1.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[0.0, 1.0]``

###### <a name='motorTracking.motorsConfig.Q3.M1.deviceId'></a>`motorTracking.motorsConfig.Q3.M1.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q3.M1.referencePos'></a>`motorTracking.motorsConfig.Q3.M1.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q3.M1.currentPos'></a>`motorTracking.motorsConfig.Q3.M1.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q3.M1'></a>`motorTracking.motorsConfig.Q3.M1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

##### `motorTracking.motorsConfig.Q3.M2`
###### <a name='motorTracking.motorsConfig.Q3.M2.axisVector'></a>`motorTracking.motorsConfig.Q3.M2.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[1.0, 0.0]``

###### <a name='motorTracking.motorsConfig.Q3.M2.deviceId'></a>`motorTracking.motorsConfig.Q3.M2.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q3.M2.referencePos'></a>`motorTracking.motorsConfig.Q3.M2.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q3.M2.currentPos'></a>`motorTracking.motorsConfig.Q3.M2.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q3.M2'></a>`motorTracking.motorsConfig.Q3.M2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.motorsConfig.Q3'></a>`motorTracking.motorsConfig.Q3`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### `motorTracking.motorsConfig.Q4`
##### `motorTracking.motorsConfig.Q4.M1`
###### <a name='motorTracking.motorsConfig.Q4.M1.axisVector'></a>`motorTracking.motorsConfig.Q4.M1.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[0.0, 1.0]``

###### <a name='motorTracking.motorsConfig.Q4.M1.deviceId'></a>`motorTracking.motorsConfig.Q4.M1.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q4.M1.referencePos'></a>`motorTracking.motorsConfig.Q4.M1.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q4.M1.currentPos'></a>`motorTracking.motorsConfig.Q4.M1.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q4.M1'></a>`motorTracking.motorsConfig.Q4.M1`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

##### `motorTracking.motorsConfig.Q4.M2`
###### <a name='motorTracking.motorsConfig.Q4.M2.axisVector'></a>`motorTracking.motorsConfig.Q4.M2.axisVector`
Type
: VECTOR_DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``[-1.0, 0.0]``

###### <a name='motorTracking.motorsConfig.Q4.M2.deviceId'></a>`motorTracking.motorsConfig.Q4.M2.deviceId`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

###### <a name='motorTracking.motorsConfig.Q4.M2.referencePos'></a>`motorTracking.motorsConfig.Q4.M2.referencePos`
Type
: DOUBLE

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

###### <a name='motorTracking.motorsConfig.Q4.M2.currentPos'></a>`motorTracking.motorsConfig.Q4.M2.currentPos`
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

##### <a name='motorTracking.motorsConfig.Q4.M2'></a>`motorTracking.motorsConfig.Q4.M2`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.motorsConfig.Q4'></a>`motorTracking.motorsConfig.Q4`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='motorTracking.motorsConfig'></a>`motorTracking.motorsConfig`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='motorTracking.positionKey'></a>`motorTracking.positionKey`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``actualPosition``

### <a name='motorTracking.tolerance'></a>`motorTracking.tolerance`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.005``

### `motorTracking.referencePositions`
#### <a name='motorTracking.referencePositions.reset'></a>Reset (`motorTracking.referencePositions.reset`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.referencePositions.fromGeometry'></a>From geometry (`motorTracking.referencePositions.fromGeometry`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

#### <a name='motorTracking.referencePositions.useCurrentPos'></a>Use current positions (`motorTracking.referencePositions.useCurrentPos`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='motorTracking.referencePositions'></a>`motorTracking.referencePositions`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='motorTracking.update'></a>Update once (`motorTracking.update`)
Type
: Slot

Allowed in states
: ACTIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

### <a name='motorTracking.toggle'></a>Toggle tracking (`motorTracking.toggle`)
Type
: Slot

Allowed in states
: ACTIVE, MONITORING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

## <a name='motorTracking'></a>`motorTracking`
Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL
