# AgipdCorrection
Base classes: [BaseCorrection](BaseCorrection.md)
## `corrections`
### `corrections.thresholding`
#### <a name='corrections.thresholding.available'></a>Available (`corrections.thresholding.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.thresholding.enable'></a>Enable (`corrections.thresholding.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``True``

#### <a name='corrections.thresholding.preview'></a>Preview (`corrections.thresholding.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``True``

### `corrections.offset`
#### <a name='corrections.offset.available'></a>Available (`corrections.offset.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.offset.enable'></a>Enable (`corrections.offset.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``True``

#### <a name='corrections.offset.preview'></a>Preview (`corrections.offset.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``True``

### `corrections.forceMgIfBelow`
#### <a name='corrections.forceMgIfBelow.available'></a>Available (`corrections.forceMgIfBelow.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.forceMgIfBelow.enable'></a>Enable (`corrections.forceMgIfBelow.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``False``

#### <a name='corrections.forceMgIfBelow.preview'></a>Preview (`corrections.forceMgIfBelow.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``False``

#### <a name='corrections.forceMgIfBelow.hardThreshold'></a>`corrections.forceMgIfBelow.hardThreshold`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If enabled, any pixels assigned to low gain stage which would be below this threshold after having medium gain offset subtracted will be reassigned to medium gain.

Default value
: ``1000.0``

### `corrections.forceHgIfBelow`
#### <a name='corrections.forceHgIfBelow.available'></a>Available (`corrections.forceHgIfBelow.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.forceHgIfBelow.enable'></a>Enable (`corrections.forceHgIfBelow.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``False``

#### <a name='corrections.forceHgIfBelow.preview'></a>Preview (`corrections.forceHgIfBelow.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``False``

#### <a name='corrections.forceHgIfBelow.hardThreshold'></a>`corrections.forceHgIfBelow.hardThreshold`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Like forceMgIfBelow, but potentially reassigning from medium gain to high gain based on threshold and pixel value minus low gain offset. Applied after forceMgIfBelow, pixels can theoretically be reassigned twice, from LG to MG and to HG.

Default value
: ``1000.0``

### `corrections.relGain`
#### <a name='corrections.relGain.available'></a>Available (`corrections.relGain.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.relGain.enable'></a>Enable (`corrections.relGain.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``True``

#### <a name='corrections.relGain.preview'></a>Preview (`corrections.relGain.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``True``

#### <a name='corrections.relGain.sourceOfSlopes'></a>Kind of slopes (`corrections.relGain.sourceOfSlopes`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Slopes for relative gain correction can be derived from pulse capacitor (PC) scans or current source scans (CS). Choose one!

Options:
: ``PC``, ``CS``

Default value
: ``PC``

#### <a name='corrections.relGain.adjustMgBaseline'></a>Adjust MG baseline (`corrections.relGain.adjustMgBaseline`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If set, an additional offset is applied to pixels in medium gain. The value of the offset is either computed per pixel (and memory cell) based on currently loaded relative gain slopes (PC or CS) or it is set to a specific value when overrideMdAdditionalOffset is set.

Default value
: ``True``

#### <a name='corrections.relGain.overrideMdAdditionalOffset'></a>Override md_additional_offset (`corrections.relGain.overrideMdAdditionalOffset`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If set, the additional offset applied to medium gain pixels (assuming adjustMgBaseline is set) will use the value from mdAdditionalOffset globally for. Otherwise, the additional offset is derived from the relevant constants.

Default value
: ``False``

#### <a name='corrections.relGain.mdAdditionalOffset'></a>Value for md_additional_offset (if overriding) (`corrections.relGain.mdAdditionalOffset`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Normally, md_additional_offset (part of relative gain correction) is computed when loading SlopesPC. In case you want to use a different value (global for all medium gain pixels), you can specify it here and set corrections.overrideMdAdditionalOffset to True.

Default value
: ``0.0``

### `corrections.gainXray`
#### <a name='corrections.gainXray.available'></a>Available (`corrections.gainXray.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``False``

#### <a name='corrections.gainXray.enable'></a>Enable (`corrections.gainXray.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``True``

#### <a name='corrections.gainXray.preview'></a>Preview (`corrections.gainXray.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``True``

#### <a name='corrections.gainXray.gGainValue'></a>G_gain_value (`corrections.gainXray.gGainValue`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Newer X-ray gain correction constants are absolute. The default G_gain_value of 1 means that output is expected to be in keV. If this is not desired, one can here specify the mean X-ray gain value over all modules to get ADU values out - operator must manually find this mean value.

Default value
: ``1.0``

### `corrections.badPixels`
#### <a name='corrections.badPixels.available'></a>Available (`corrections.badPixels.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``True``

#### <a name='corrections.badPixels.enable'></a>Enable (`corrections.badPixels.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``True``

#### <a name='corrections.badPixels.preview'></a>Preview (`corrections.badPixels.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``True``

#### <a name='corrections.badPixels.maskingValue'></a>Bad pixel masking value (`corrections.badPixels.maskingValue`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Any pixels masked by the bad pixel mask will have their value replaced with this. Note that this parameter is to be interpreted as a numpy.float32; use 'nan' to get NaN value.

Default value
: ``nan``

#### Bad pixel flags to use (`corrections.badPixels.subsetToUse`)
The booleans under this node allow for selecting a subset of bad pixel types to take into account when doing bad pixel masking. Upon updating these flags, the map used for bad pixel masking will be ANDed with this selection. Turning disabled flags back on causes reloading of cached constants.
##### <a name='corrections.badPixels.subsetToUse.OFFSET_OUT_OF_THRESHOLD'></a>`corrections.badPixels.subsetToUse.OFFSET_OUT_OF_THRESHOLD`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NOISE_OUT_OF_THRESHOLD'></a>`corrections.badPixels.subsetToUse.NOISE_OUT_OF_THRESHOLD`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.OFFSET_NOISE_EVAL_ERROR'></a>`corrections.badPixels.subsetToUse.OFFSET_NOISE_EVAL_ERROR`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NO_DARK_DATA'></a>`corrections.badPixels.subsetToUse.NO_DARK_DATA`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.CI_GAIN_OUT_OF_THRESHOLD'></a>`corrections.badPixels.subsetToUse.CI_GAIN_OUT_OF_THRESHOLD`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.CI_LINEAR_DEVIATION'></a>`corrections.badPixels.subsetToUse.CI_LINEAR_DEVIATION`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.CI_EVAL_ERROR'></a>`corrections.badPixels.subsetToUse.CI_EVAL_ERROR`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.FF_GAIN_EVAL_ERROR'></a>`corrections.badPixels.subsetToUse.FF_GAIN_EVAL_ERROR`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.FF_GAIN_DEVIATION'></a>`corrections.badPixels.subsetToUse.FF_GAIN_DEVIATION`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.FF_NO_ENTRIES'></a>`corrections.badPixels.subsetToUse.FF_NO_ENTRIES`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.CI2_EVAL_ERROR'></a>`corrections.badPixels.subsetToUse.CI2_EVAL_ERROR`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.VALUE_IS_NAN'></a>`corrections.badPixels.subsetToUse.VALUE_IS_NAN`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.VALUE_OUT_OF_RANGE'></a>`corrections.badPixels.subsetToUse.VALUE_OUT_OF_RANGE`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.GAIN_THRESHOLDING_ERROR'></a>`corrections.badPixels.subsetToUse.GAIN_THRESHOLDING_ERROR`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.DATA_STD_IS_ZERO'></a>`corrections.badPixels.subsetToUse.DATA_STD_IS_ZERO`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.ASIC_STD_BELOW_NOISE'></a>`corrections.badPixels.subsetToUse.ASIC_STD_BELOW_NOISE`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.INTERPOLATED'></a>`corrections.badPixels.subsetToUse.INTERPOLATED`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NOISY_ADC'></a>`corrections.badPixels.subsetToUse.NOISY_ADC`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.OVERSCAN'></a>`corrections.badPixels.subsetToUse.OVERSCAN`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NON_SENSITIVE'></a>`corrections.badPixels.subsetToUse.NON_SENSITIVE`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NON_LIN_RESPONSE_REGION'></a>`corrections.badPixels.subsetToUse.NON_LIN_RESPONSE_REGION`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.WRONG_GAIN_VALUE'></a>`corrections.badPixels.subsetToUse.WRONG_GAIN_VALUE`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

##### <a name='corrections.badPixels.subsetToUse.NON_STANDARD_SIZE'></a>`corrections.badPixels.subsetToUse.NON_STANDARD_SIZE`
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

### `corrections.commonMode`
#### <a name='corrections.commonMode.available'></a>Available (`corrections.commonMode.available`)
Type
: BOOL

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This boolean indicates whether the necessary constants have been loaded for this correction step to be applied. Enabling the correction will have no effect unless this is True.

Default value
: ``True``

#### <a name='corrections.commonMode.enable'></a>Enable (`corrections.commonMode.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Controls whether to apply this correction step for main data output - subject to availability.

Default value
: ``False``

#### <a name='corrections.commonMode.preview'></a>Preview (`corrections.commonMode.preview`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Whether to apply this correction step for corrected preview output - subject to availability.

Default value
: ``False``

#### <a name='corrections.commonMode.iterations'></a>`corrections.commonMode.iterations`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``4``

#### <a name='corrections.commonMode.minFrac'></a>`corrections.commonMode.minFrac`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.15000000596046448``

#### <a name='corrections.commonMode.noisePeakRange'></a>`corrections.commonMode.noisePeakRange`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``35.0``

## Addons (`addons`)
### `addons.IntegratedIntensity`
#### <a name='addons.IntegratedIntensity.enable'></a>`addons.IntegratedIntensity.enable`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

#### <a name='addons.IntegratedIntensity.valueMin'></a>`addons.IntegratedIntensity.valueMin`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``-10.0``

#### <a name='addons.IntegratedIntensity.valueMax'></a>`addons.IntegratedIntensity.valueMax`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``20000.0``

### `addons.LitPixelCounter`
#### <a name='addons.LitPixelCounter.enable'></a>`addons.LitPixelCounter.enable`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

#### <a name='addons.LitPixelCounter.threshold'></a>`addons.LitPixelCounter.threshold`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``6.0``

### `addons.Peakfinder9`
#### <a name='addons.Peakfinder9.enable'></a>`addons.Peakfinder9.enable`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

#### <a name='addons.Peakfinder9.windowRadius'></a>`addons.Peakfinder9.windowRadius`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``2``

#### <a name='addons.Peakfinder9.maxPeaks'></a>`addons.Peakfinder9.maxPeaks`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``500``

#### <a name='addons.Peakfinder9.minPeakValueOverNeighbors'></a>`addons.Peakfinder9.minPeakValueOverNeighbors`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``10.0``

#### <a name='addons.Peakfinder9.minSnrMaxPixel'></a>`addons.Peakfinder9.minSnrMaxPixel`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``5.0``

#### <a name='addons.Peakfinder9.minSnrPeakPixels'></a>`addons.Peakfinder9.minSnrPeakPixels`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``4.0``

#### <a name='addons.Peakfinder9.minSnrWholePeak'></a>`addons.Peakfinder9.minSnrWholePeak`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``6.0``

#### <a name='addons.Peakfinder9.minSigma'></a>`addons.Peakfinder9.minSigma`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``5.0``

#### <a name='addons.Peakfinder9.blockX'></a>`addons.Peakfinder9.blockX`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``1``

#### <a name='addons.Peakfinder9.blockY'></a>`addons.Peakfinder9.blockY`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``1``

#### <a name='addons.Peakfinder9.blockZ'></a>`addons.Peakfinder9.blockZ`
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``64``

### `addons.RandomFrames`
#### <a name='addons.RandomFrames.enable'></a>`addons.RandomFrames.enable`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

#### <a name='addons.RandomFrames.probability'></a>`addons.RandomFrames.probability`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``50.0``

### `addons.SaturationMonitor`
#### <a name='addons.SaturationMonitor.enable'></a>`addons.SaturationMonitor.enable`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``False``

#### <a name='addons.SaturationMonitor.alarmThreshold'></a>`addons.SaturationMonitor.alarmThreshold`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Alarm threshold per pixel.

Default value
: ``0.0``

#### <a name='addons.SaturationMonitor.warnThreshold'></a>`addons.SaturationMonitor.warnThreshold`
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Warning threshold per pixel.

Default value
: ``0.0``

#### <a name='addons.SaturationMonitor.alarmMaxCount'></a>`addons.SaturationMonitor.alarmMaxCount`
Type
: UINT64

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Maximum number of pixel above alarm threshold.

Default value
: ``0``

#### <a name='addons.SaturationMonitor.warnMaxCount'></a>`addons.SaturationMonitor.warnMaxCount`
Type
: UINT64

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Maximum number of pixel above warn threshold.

Default value
: ``0``

#### <a name='addons.SaturationMonitor.frameAxis'></a>Multi-frame axis (`addons.SaturationMonitor.frameAxis`)
Type
: UINT64

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Axis for frames. Used to take the max over this axis.

Default value
: ``0``

#### `addons.SaturationMonitor.output`
OutputChannel
## Constant retrieval parameters (`constantParameters`)
### <a name='constantParameters.secretsFile'></a>CalCat secrets file (`constantParameters.secretsFile`)
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Description
: Path to JSON file specifying secret token and some parameters used to access CalCat.

Default value
: ``~/.calcat-secrets.json``

### <a name='constantParameters.deviceMappingSnapshotAt'></a>Snapshot timestamp (for device mapping) (`constantParameters.deviceMappingSnapshotAt`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: CalCat supports querying with a specific snapshot of the database. When playing back a run from the file system, this feature is useful to look up the device mapping at the time of the run. If this field is left empty, the latest device mapping is used. Date format should be 'YYYY-MM-DD' with optional time of day starting with 'T' followed by 'hh:mm:ss.mil+02:00'.

Default value
: empty string

### <a name='constantParameters.constantVersionEventAt'></a>Event at timestamp (for constant version) (`constantParameters.constantVersionEventAt`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: TODO

Default value
: empty string

### <a name='constantParameters.detectorType'></a>Detector type name (`constantParameters.detectorType`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Name of detector type in CalCat; typically has suffix '-Type'

Default value
: ``AGIPD-Type``

### <a name='constantParameters.detectorTypeId'></a>`constantParameters.detectorTypeId`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: empty string

### <a name='constantParameters.detectorName'></a>`constantParameters.detectorName`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

### <a name='constantParameters.detectorId'></a>`constantParameters.detectorId`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: empty string

### <a name='constantParameters.karaboDa'></a>`constantParameters.karaboDa`
Type
: STRING

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: empty string

### <a name='constantParameters.moduleId'></a>`constantParameters.moduleId`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: empty string

### <a name='constantParameters.memoryCells'></a>Memory cells (`constantParameters.memoryCells`)
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Number of memory cells / frames per train. Relevant for burst mode.

Default value
: ``352``

### <a name='constantParameters.pixelsX'></a>Pixels X (`constantParameters.pixelsX`)
Type
: UINT32

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``512``

### <a name='constantParameters.pixelsY'></a>Pixels Y (`constantParameters.pixelsY`)
Type
: UINT32

Access mode
: INITONLY

Assignment
: OPTIONAL

Default value
: ``128``

### <a name='constantParameters.biasVoltage'></a>Bias voltage (`constantParameters.biasVoltage`)
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Sensor bias voltage

Default value
: ``300``

### <a name='constantParameters.acquisitionRate'></a>`constantParameters.acquisitionRate`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``1.1``

### <a name='constantParameters.gainSetting'></a>`constantParameters.gainSetting`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

### <a name='constantParameters.photonEnergy'></a>`constantParameters.photonEnergy`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``9.2``

### <a name='constantParameters.gainMode'></a>`constantParameters.gainMode`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Options:
: ``ADAPTIVE_GAIN``, ``FIXED_HIGH_GAIN``, ``FIXED_MEDIUM_GAIN``, ``FIXED_LOW_GAIN``

Default value
: ``ADAPTIVE_GAIN``

### <a name='constantParameters.integrationTime'></a>`constantParameters.integrationTime`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``12.0``

## Constants retrieved (`foundConstants`)
### `foundConstants.ThresholdsDark`
#### <a name='foundConstants.ThresholdsDark.state'></a>`foundConstants.ThresholdsDark.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.ThresholdsDark.loadMostRecent'></a>Load most recent (`foundConstants.ThresholdsDark.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.ThresholdsDark.beginValidityAt'></a>Constant timestamp (`foundConstants.ThresholdsDark.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.ThresholdsDark.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.ThresholdsDark.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.ThresholdsDark.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.ThresholdsDark.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.ThresholdsDark.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.ThresholdsDark.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.ThresholdsDark.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.ThresholdsDark.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.overrideConstantFromVersion'></a>Override constant version (`foundConstants.ThresholdsDark.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.ThresholdsDark.dataFilePath'></a>Data file path (`foundConstants.ThresholdsDark.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.dataSetName'></a>Data set name (`foundConstants.ThresholdsDark.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.ThresholdsDark.constantLoadingTime'></a>FS load time (`foundConstants.ThresholdsDark.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.ThresholdsDark.overrideConstantFromFile'></a>Override from file (`foundConstants.ThresholdsDark.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.Offset`
#### <a name='foundConstants.Offset.state'></a>`foundConstants.Offset.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.Offset.loadMostRecent'></a>Load most recent (`foundConstants.Offset.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.Offset.beginValidityAt'></a>Constant timestamp (`foundConstants.Offset.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.Offset.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.Offset.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.Offset.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.Offset.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.Offset.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.Offset.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.Offset.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.Offset.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.Offset.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.Offset.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.Offset.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.Offset.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.Offset.overrideConstantFromVersion'></a>Override constant version (`foundConstants.Offset.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.Offset.dataFilePath'></a>Data file path (`foundConstants.Offset.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.Offset.dataSetName'></a>Data set name (`foundConstants.Offset.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.Offset.constantLoadingTime'></a>FS load time (`foundConstants.Offset.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.Offset.overrideConstantFromFile'></a>Override from file (`foundConstants.Offset.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.SlopesCS`
#### <a name='foundConstants.SlopesCS.state'></a>`foundConstants.SlopesCS.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.SlopesCS.loadMostRecent'></a>Load most recent (`foundConstants.SlopesCS.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.SlopesCS.beginValidityAt'></a>Constant timestamp (`foundConstants.SlopesCS.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.SlopesCS.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.SlopesCS.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.SlopesCS.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.SlopesCS.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.SlopesCS.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.SlopesCS.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesCS.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.SlopesCS.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.SlopesCS.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.SlopesCS.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesCS.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.SlopesCS.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.SlopesCS.overrideConstantFromVersion'></a>Override constant version (`foundConstants.SlopesCS.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.SlopesCS.dataFilePath'></a>Data file path (`foundConstants.SlopesCS.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.SlopesCS.dataSetName'></a>Data set name (`foundConstants.SlopesCS.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.SlopesCS.constantLoadingTime'></a>FS load time (`foundConstants.SlopesCS.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.SlopesCS.overrideConstantFromFile'></a>Override from file (`foundConstants.SlopesCS.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.SlopesPC`
#### <a name='foundConstants.SlopesPC.state'></a>`foundConstants.SlopesPC.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.SlopesPC.loadMostRecent'></a>Load most recent (`foundConstants.SlopesPC.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.SlopesPC.beginValidityAt'></a>Constant timestamp (`foundConstants.SlopesPC.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.SlopesPC.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.SlopesPC.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.SlopesPC.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.SlopesPC.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.SlopesPC.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.SlopesPC.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesPC.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.SlopesPC.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.SlopesPC.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.SlopesPC.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesPC.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.SlopesPC.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.SlopesPC.overrideConstantFromVersion'></a>Override constant version (`foundConstants.SlopesPC.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.SlopesPC.dataFilePath'></a>Data file path (`foundConstants.SlopesPC.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.SlopesPC.dataSetName'></a>Data set name (`foundConstants.SlopesPC.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.SlopesPC.constantLoadingTime'></a>FS load time (`foundConstants.SlopesPC.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.SlopesPC.overrideConstantFromFile'></a>Override from file (`foundConstants.SlopesPC.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.SlopesFF`
#### <a name='foundConstants.SlopesFF.state'></a>`foundConstants.SlopesFF.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.SlopesFF.loadMostRecent'></a>Load most recent (`foundConstants.SlopesFF.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.SlopesFF.beginValidityAt'></a>Constant timestamp (`foundConstants.SlopesFF.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.SlopesFF.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.SlopesFF.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.SlopesFF.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.SlopesFF.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.SlopesFF.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.SlopesFF.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesFF.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.SlopesFF.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.SlopesFF.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.SlopesFF.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.SlopesFF.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.SlopesFF.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.SlopesFF.overrideConstantFromVersion'></a>Override constant version (`foundConstants.SlopesFF.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.SlopesFF.dataFilePath'></a>Data file path (`foundConstants.SlopesFF.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.SlopesFF.dataSetName'></a>Data set name (`foundConstants.SlopesFF.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.SlopesFF.constantLoadingTime'></a>FS load time (`foundConstants.SlopesFF.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.SlopesFF.overrideConstantFromFile'></a>Override from file (`foundConstants.SlopesFF.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.BadPixelsDark`
#### <a name='foundConstants.BadPixelsDark.state'></a>`foundConstants.BadPixelsDark.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.BadPixelsDark.loadMostRecent'></a>Load most recent (`foundConstants.BadPixelsDark.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.BadPixelsDark.beginValidityAt'></a>Constant timestamp (`foundConstants.BadPixelsDark.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.BadPixelsDark.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.BadPixelsDark.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsDark.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.BadPixelsDark.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.BadPixelsDark.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsDark.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.BadPixelsDark.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.BadPixelsDark.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.overrideConstantFromVersion'></a>Override constant version (`foundConstants.BadPixelsDark.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.BadPixelsDark.dataFilePath'></a>Data file path (`foundConstants.BadPixelsDark.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.dataSetName'></a>Data set name (`foundConstants.BadPixelsDark.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsDark.constantLoadingTime'></a>FS load time (`foundConstants.BadPixelsDark.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.BadPixelsDark.overrideConstantFromFile'></a>Override from file (`foundConstants.BadPixelsDark.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.BadPixelsCS`
#### <a name='foundConstants.BadPixelsCS.state'></a>`foundConstants.BadPixelsCS.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.BadPixelsCS.loadMostRecent'></a>Load most recent (`foundConstants.BadPixelsCS.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.BadPixelsCS.beginValidityAt'></a>Constant timestamp (`foundConstants.BadPixelsCS.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.BadPixelsCS.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.BadPixelsCS.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsCS.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.BadPixelsCS.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.BadPixelsCS.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsCS.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.BadPixelsCS.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.BadPixelsCS.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.overrideConstantFromVersion'></a>Override constant version (`foundConstants.BadPixelsCS.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.BadPixelsCS.dataFilePath'></a>Data file path (`foundConstants.BadPixelsCS.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.dataSetName'></a>Data set name (`foundConstants.BadPixelsCS.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsCS.constantLoadingTime'></a>FS load time (`foundConstants.BadPixelsCS.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.BadPixelsCS.overrideConstantFromFile'></a>Override from file (`foundConstants.BadPixelsCS.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.BadPixelsPC`
#### <a name='foundConstants.BadPixelsPC.state'></a>`foundConstants.BadPixelsPC.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.BadPixelsPC.loadMostRecent'></a>Load most recent (`foundConstants.BadPixelsPC.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.BadPixelsPC.beginValidityAt'></a>Constant timestamp (`foundConstants.BadPixelsPC.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.BadPixelsPC.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.BadPixelsPC.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsPC.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.BadPixelsPC.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.BadPixelsPC.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsPC.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.BadPixelsPC.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.BadPixelsPC.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.overrideConstantFromVersion'></a>Override constant version (`foundConstants.BadPixelsPC.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.BadPixelsPC.dataFilePath'></a>Data file path (`foundConstants.BadPixelsPC.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.dataSetName'></a>Data set name (`foundConstants.BadPixelsPC.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsPC.constantLoadingTime'></a>FS load time (`foundConstants.BadPixelsPC.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.BadPixelsPC.overrideConstantFromFile'></a>Override from file (`foundConstants.BadPixelsPC.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

### `foundConstants.BadPixelsFF`
#### <a name='foundConstants.BadPixelsFF.state'></a>`foundConstants.BadPixelsFF.state`
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``OFF``

#### <a name='foundConstants.BadPixelsFF.loadMostRecent'></a>Load most recent (`foundConstants.BadPixelsFF.loadMostRecent`)
Type
: Slot

Access mode
: RECONFIGURABLE

#### <a name='foundConstants.BadPixelsFF.beginValidityAt'></a>Constant timestamp (`foundConstants.BadPixelsFF.beginValidityAt`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: This field displays the field 'begin_validity_at' from CalCat of the most recently found + loaded constant. This field is tied to when the constant was created and is useful to notice if some constants are out of date.

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.calibrationId'></a>[CalCat] Calibration ID (`foundConstants.BadPixelsFF.calibrationId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, each constant type is associated with a calibration ID (for example, 'Offset' has ID 1). If calibration ID is not found, something is quite wrong: missing in CalCat or issue with correction device.

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.conditionIds'></a>[CalCat] Condition IDs found (`foundConstants.BadPixelsFF.conditionIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, constants are found based on Physical Detector Unit and the operating condition of the detector. A condition ID represents a match on these. As operating conditions can overlap, a query may involve multiple valid condition IDs; the retrieval strategy later ('closest in time') will determine which candidate constant is loaded.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsFF.usedConditionId'></a>[CalCat] Condition ID used (`foundConstants.BadPixelsFF.usedConditionId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the condition IDs found, this one applies to the constant that was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.constantIds'></a>[CalCat] Constant IDs found (`foundConstants.BadPixelsFF.constantIds`)
Type
: VECTOR_UINT32

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: In CalCat, a 'constant' represents matching 'calibration ID', 'detector type ID', and 'condition ID'. Similar to condition IDs, a query may yield multiple candidate constant IDs.

Default value
: ``[]``

#### <a name='foundConstants.BadPixelsFF.usedConstantId'></a>[CalCat] Constant ID used (`foundConstants.BadPixelsFF.usedConstantId`)
Type
: STRING

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: Of the candidate constant IDs, this one applies to the constant which was retrieved in the end.

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.constantVersionId'></a>[CalCat] Constant version ID (`foundConstants.BadPixelsFF.constantVersionId`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Finally, a constant version represents a concrete constant that can be loaded (see descriptions of preceding fields for details on other steps). This field is editable - if for any reason a specific constant version is desired, the constant version ID (as used in CalCat) can be set here and the slot below can be called to load this particular version. Only relevant in very unusual situations.

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.overrideConstantFromVersion'></a>Override constant version (`foundConstants.BadPixelsFF.overrideConstantFromVersion`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: See description of constant version id.

#### <a name='foundConstants.BadPixelsFF.dataFilePath'></a>Data file path (`foundConstants.BadPixelsFF.dataFilePath`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Where is the actual file for the constant located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.dataSetName'></a>Data set name (`foundConstants.BadPixelsFF.dataSetName`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Within the actual data file, where is the constant data located?

Default value
: empty string

#### <a name='foundConstants.BadPixelsFF.constantLoadingTime'></a>FS load time (`foundConstants.BadPixelsFF.constantLoadingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Description
: How long it took loading this constant from the file system

Default value
: ``0.0``

#### <a name='foundConstants.BadPixelsFF.overrideConstantFromFile'></a>Override from file (`foundConstants.BadPixelsFF.overrideConstantFromFile`)
Type
: Slot

Access mode
: RECONFIGURABLE

Description
: Constant from manually specified .h5 file and data set name

## Preview (`preview`)
Output specifically intended for preview in Karabo GUI. Includes some options for throttling and adjustments of the output data.
### `preview.raw`
#### <a name='preview.raw.swapAxes'></a>Swap slow / fast scan (`preview.raw.swapAxes`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Swaps the two pixel axes around. Can be combined with flipping to rotate the image

Default value
: ``False``

#### <a name='preview.raw.flipSS'></a>Flip SS (`preview.raw.flipSS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along slow scan axis.

Default value
: ``False``

#### <a name='preview.raw.flipFS'></a>Flip FS (`preview.raw.flipFS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along fast scan axis.

Default value
: ``False``

#### <a name='preview.raw.downsamplingFactor'></a>Downsampling factor (`preview.raw.downsamplingFactor`)
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If greater than 1, the preview image will be downsampled by this factor before sending. This is mostly to save bandwidth in case GUI updates start lagging.

Options:
: ``1``, ``2``, ``4``, ``8``

Default value
: ``1``

#### <a name='preview.raw.downsamplingFunction'></a>Downsampling function (`preview.raw.downsamplingFunction`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Reduction function used during downsampling.

Options:
: ``nanmax``, ``nanmean``, ``nanmin``, ``nanmedian``

Default value
: ``nanmax``

#### <a name='preview.raw.replaceNanWith'></a>NaN replacement (`preview.raw.replaceNanWith`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Displaying images in KaraboGUI seems to not go well when there are NaN values in data. And there will be with bad pixel masking or just geometry space between modules. NaN values get replaced with this value to get around this; choose a value which clearly stands out from the image data you want to see.

Default value
: ``0.0``

#### <a name='preview.raw.selectionMode'></a>Index selection mode (`preview.raw.selectionMode`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The value of preview.index can be used in multiple ways, controlled by this value. If this is set to 'frame', preview.index is sliced directly from data. If 'cell' (or 'pulse') is selected, I will look at cell (or pulse) table for the requested cell (or pulse ID). Special (stat) index values <0 are not affected by this.

Options:
: ``frame``, ``cell``, ``pulse``

Default value
: ``frame``

#### <a name='preview.raw.index'></a>Index (or stat) for preview (`preview.raw.index`)
Type
: INT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this value is ≥ 0, the corresponding index (frame, cell, or pulse) will be sliced for the preview output. If this value is <0, preview will be one of the following stats: -1: max, -2: mean, -3: sum, -4: stdev. These stats are computed across frames, ignoring NaN values.

Default value
: ``0``

#### `preview.raw.output`
See description of grandparent node, 'preview'.
OutputChannel
### `preview.corrected`
#### <a name='preview.corrected.swapAxes'></a>Swap slow / fast scan (`preview.corrected.swapAxes`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Swaps the two pixel axes around. Can be combined with flipping to rotate the image

Default value
: ``False``

#### <a name='preview.corrected.flipSS'></a>Flip SS (`preview.corrected.flipSS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along slow scan axis.

Default value
: ``False``

#### <a name='preview.corrected.flipFS'></a>Flip FS (`preview.corrected.flipFS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along fast scan axis.

Default value
: ``False``

#### <a name='preview.corrected.downsamplingFactor'></a>Downsampling factor (`preview.corrected.downsamplingFactor`)
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If greater than 1, the preview image will be downsampled by this factor before sending. This is mostly to save bandwidth in case GUI updates start lagging.

Options:
: ``1``, ``2``, ``4``, ``8``

Default value
: ``1``

#### <a name='preview.corrected.downsamplingFunction'></a>Downsampling function (`preview.corrected.downsamplingFunction`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Reduction function used during downsampling.

Options:
: ``nanmax``, ``nanmean``, ``nanmin``, ``nanmedian``

Default value
: ``nanmax``

#### <a name='preview.corrected.replaceNanWith'></a>NaN replacement (`preview.corrected.replaceNanWith`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Displaying images in KaraboGUI seems to not go well when there are NaN values in data. And there will be with bad pixel masking or just geometry space between modules. NaN values get replaced with this value to get around this; choose a value which clearly stands out from the image data you want to see.

Default value
: ``0.0``

#### <a name='preview.corrected.selectionMode'></a>Index selection mode (`preview.corrected.selectionMode`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The value of preview.index can be used in multiple ways, controlled by this value. If this is set to 'frame', preview.index is sliced directly from data. If 'cell' (or 'pulse') is selected, I will look at cell (or pulse) table for the requested cell (or pulse ID). Special (stat) index values <0 are not affected by this.

Options:
: ``frame``, ``cell``, ``pulse``

Default value
: ``frame``

#### <a name='preview.corrected.index'></a>Index (or stat) for preview (`preview.corrected.index`)
Type
: INT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this value is ≥ 0, the corresponding index (frame, cell, or pulse) will be sliced for the preview output. If this value is <0, preview will be one of the following stats: -1: max, -2: mean, -3: sum, -4: stdev. These stats are computed across frames, ignoring NaN values.

Default value
: ``0``

#### `preview.corrected.output`
See description of grandparent node, 'preview'.
OutputChannel
### `preview.rawGain`
#### <a name='preview.rawGain.swapAxes'></a>Swap slow / fast scan (`preview.rawGain.swapAxes`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Swaps the two pixel axes around. Can be combined with flipping to rotate the image

Default value
: ``False``

#### <a name='preview.rawGain.flipSS'></a>Flip SS (`preview.rawGain.flipSS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along slow scan axis.

Default value
: ``False``

#### <a name='preview.rawGain.flipFS'></a>Flip FS (`preview.rawGain.flipFS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along fast scan axis.

Default value
: ``False``

#### <a name='preview.rawGain.downsamplingFactor'></a>Downsampling factor (`preview.rawGain.downsamplingFactor`)
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If greater than 1, the preview image will be downsampled by this factor before sending. This is mostly to save bandwidth in case GUI updates start lagging.

Options:
: ``1``, ``2``, ``4``, ``8``

Default value
: ``1``

#### <a name='preview.rawGain.downsamplingFunction'></a>Downsampling function (`preview.rawGain.downsamplingFunction`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Reduction function used during downsampling.

Options:
: ``nanmax``, ``nanmean``, ``nanmin``, ``nanmedian``

Default value
: ``nanmax``

#### <a name='preview.rawGain.replaceNanWith'></a>NaN replacement (`preview.rawGain.replaceNanWith`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Displaying images in KaraboGUI seems to not go well when there are NaN values in data. And there will be with bad pixel masking or just geometry space between modules. NaN values get replaced with this value to get around this; choose a value which clearly stands out from the image data you want to see.

Default value
: ``0.0``

#### <a name='preview.rawGain.selectionMode'></a>Index selection mode (`preview.rawGain.selectionMode`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The value of preview.index can be used in multiple ways, controlled by this value. If this is set to 'frame', preview.index is sliced directly from data. If 'cell' (or 'pulse') is selected, I will look at cell (or pulse) table for the requested cell (or pulse ID). Special (stat) index values <0 are not affected by this.

Options:
: ``frame``, ``cell``, ``pulse``

Default value
: ``frame``

#### <a name='preview.rawGain.index'></a>Index (or stat) for preview (`preview.rawGain.index`)
Type
: INT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this value is ≥ 0, the corresponding index (frame, cell, or pulse) will be sliced for the preview output. If this value is <0, preview will be one of the following stats: -1: max, -2: mean, -3: sum, -4: stdev. These stats are computed across frames, ignoring NaN values.

Default value
: ``0``

#### `preview.rawGain.output`
See description of grandparent node, 'preview'.
OutputChannel
### `preview.gainMap`
#### <a name='preview.gainMap.swapAxes'></a>Swap slow / fast scan (`preview.gainMap.swapAxes`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Swaps the two pixel axes around. Can be combined with flipping to rotate the image

Default value
: ``False``

#### <a name='preview.gainMap.flipSS'></a>Flip SS (`preview.gainMap.flipSS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along slow scan axis.

Default value
: ``False``

#### <a name='preview.gainMap.flipFS'></a>Flip FS (`preview.gainMap.flipFS`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Flip image data along fast scan axis.

Default value
: ``False``

#### <a name='preview.gainMap.downsamplingFactor'></a>Downsampling factor (`preview.gainMap.downsamplingFactor`)
Type
: UINT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If greater than 1, the preview image will be downsampled by this factor before sending. This is mostly to save bandwidth in case GUI updates start lagging.

Options:
: ``1``, ``2``, ``4``, ``8``

Default value
: ``1``

#### <a name='preview.gainMap.downsamplingFunction'></a>Downsampling function (`preview.gainMap.downsamplingFunction`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Reduction function used during downsampling.

Options:
: ``nanmax``, ``nanmean``, ``nanmin``, ``nanmedian``

Default value
: ``nanmax``

#### <a name='preview.gainMap.replaceNanWith'></a>NaN replacement (`preview.gainMap.replaceNanWith`)
Type
: FLOAT

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Displaying images in KaraboGUI seems to not go well when there are NaN values in data. And there will be with bad pixel masking or just geometry space between modules. NaN values get replaced with this value to get around this; choose a value which clearly stands out from the image data you want to see.

Default value
: ``0.0``

#### <a name='preview.gainMap.selectionMode'></a>Index selection mode (`preview.gainMap.selectionMode`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The value of preview.index can be used in multiple ways, controlled by this value. If this is set to 'frame', preview.index is sliced directly from data. If 'cell' (or 'pulse') is selected, I will look at cell (or pulse) table for the requested cell (or pulse ID). Special (stat) index values <0 are not affected by this.

Options:
: ``frame``, ``cell``, ``pulse``

Default value
: ``frame``

#### <a name='preview.gainMap.index'></a>Index (or stat) for preview (`preview.gainMap.index`)
Type
: INT32

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: If this value is ≥ 0, the corresponding index (frame, cell, or pulse) will be sliced for the preview output. If this value is <0, preview will be one of the following stats: -1: max, -2: mean, -3: sum, -4: stdev. These stats are computed across frames, ignoring NaN values.

Default value
: ``0``

#### `preview.gainMap.output`
See description of grandparent node, 'preview'.
OutputChannel
## `dataOutput`
OutputChannel
## <a name='kernelType'></a>`kernelType`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Options:
: ``GPU``, ``CPU``

Default value
: ``GPU``
