# Arbiter kernel: ReduceAndThreshold
## `prefix`
This kernel allows custom frame masks based on comparing some reduction along modules over each frame to some threshold. Integrated intensity will be used as a running example in the descriptions of the properties under this node; these settings (used with the example integrated intensity addon) would yield a frame mask of frames with total (across modules) integrated intensity of at least [threshold] ADUs.
### <a name='prefix.key'></a>`prefix.key`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The key in the input hashes which holds the data values for reduction and comparison. Typically some summary computed per frame by an addon; for example, 'image.integratedIntensity'

Default value
: empty string

### <a name='prefix.threshold'></a>`prefix.threshold`
Type
: DOUBLE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``0.0``

### <a name='prefix.reduction'></a>`prefix.reduction`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The reduction to apply across modules before comparing with the threshold. For example 'sum'.

Options:
: ``sum``, ``mean``, ``max``, ``min``, ``std``

Default value
: ``sum``

### <a name='prefix.comparator'></a>`prefix.comparator`
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: The comparator to use for comparing the reduced per-frame values to the threshold. For the integrated intensity example, 'ge'. The reduced values will be on the left and the threshold will be on the right, so the example would be compute: mask = sum(integrated intensity) ≥ threshold.

Options:
: ``lt``, ``le``, ``gt``, ``ge``, ``eq``, ``ne``

Default value
: ``ge``
