# ShmemTrainMatcher
Base classes: [TrainMatcher](TrainMatcher.md)
## <a name='enableKaraboOutput'></a>Enable Karabo channel (`enableKaraboOutput`)
Type
: BOOL

Allowed in states
: PASSIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``True``

## <a name='processingTime'></a>Processing time (`processingTime`)
Type
: DOUBLE

Access mode
: READONLY

Assignment
: OPTIONAL

Default value
: ``0.0``

## <a name='processingThreads'></a>`processingThreads`
Type
: UINT32

Allowed in states
: PASSIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``16``

## <a name='useInfiniband'></a>`useInfiniband`
Type
: BOOL

Access mode
: INITONLY

Assignment
: OPTIONAL

Description
: If enabled, device will during initialization try to bind its data output channel (output) to its node's infiniband interface. Default interface is used if no 'ib0' interface is found.

Default value
: ``True``

## Frame selection (`frameSelector`)
### <a name='frameSelector.enable'></a>Enabled (`frameSelector.enable`)
Type
: BOOL

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Default value
: ``False``

### <a name='frameSelector.arbiterSource'></a>Arbiter source (`frameSelector.arbiterSource`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Source name to pull the frame selection pattern from, must be part of matched sources.

Default value
: empty string

### <a name='frameSelector.dataSourcePattern'></a>Data source pattern (`frameSelector.dataSourcePattern`)
Type
: STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Source name pattern to apply frame selection to.  Should match subset of matched sources.

Default value
: empty string

### <a name='frameSelector.dataKeys'></a>Data keys (`frameSelector.dataKeys`)
Type
: VECTOR_STRING

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Keys in data sources to apply frame selection to.

Default value
: ``[]``

## <a name='merge'></a>Array stacking (`merge`)
Type
: VECTOR_HASH

Allowed in states
: PASSIVE

Access mode
: RECONFIGURABLE

Assignment
: OPTIONAL

Description
: Specify which source(s) or key(s) to stack or interleave.When stacking sources, the 'Source pattern' is interpreted as a regular expression and the 'Key pattern' is interpreted as an ordinary string. From all sources matching the source pattern, the data under this key (should be array with same dimensions across all stacked sources) is stacked in the same order as the sources are listed in 'Data sources' and the result is under the same key name in a new source named by 'Replacement'. When stacking keys, both the 'Source pattern' and the 'Key pattern' are regular expressions. Within each source matching the source pattern, all keys matching the key pattern are stacked and the result is put under the key named by 'Replacement'. While source stacking is optimized and can use thread pool, key stacking will iterate over all paths in matched sources and naively call np.stack for each key pattern. In either case, data that is used for stacking is removed from its original location (e.g. key is erased from hash). In both cases, the data can alternatively be interleaved. This is essentially equivalent to stacking except followed by a reshape such that the output is shaped like concatenation.

Table schema and default value
: 
| Select | Source pattern | Key pattern | Replacement | Group type | Merge method | Axis | Missing value default |
| - | - | - | - | - | - | - | - |

